/* --------------------------------------------

 	Typemaps MACROS

Version 1.0 AP 04/08/2004
 --------------------------------------------*/

/* so that WR_desc may accept direct values */

%typemap(in) void *in_descval(short sval, int ip, float fval, double dp, char *cp) {

        switch(arg3) {

            case CHAR :
            cp = Tcl_GetStringFromObj($input,0);
            $1 = (void *)cp;
            break;

            case SHORT :
            Tcl_GetIntFromObj(interp, $input, &ip);
            sval = (short)ip;
            $1 = (void *)&sval;
            break;

            case INT :
            case LONG :
            Tcl_GetIntFromObj(interp, $input, &ip);
            $1 = (void *)&ip;
            break;

            case FLOAT :
            Tcl_GetDoubleFromObj(interp, $input, &dp);
            fval = (float)dp;
            $1 = (void *)&fval;
            break;

            case DOUBLE :
            Tcl_GetDoubleFromObj(interp, $input, &dp);
            $1 = (void *)&dp;
            break;
        }
}

/* so that RD_desc may accept tcl object to return values */

%typemap(in) void *out_descval {
	
	switch(arg3) {

            case CHAR :
            $1 = (void *)malloc((arg4+1)*sizeof(char));
            break;
            case SHORT :
            $1 = (void *)malloc(arg4*sizeof(short));
            break;
            case INT :
            case LONG :
            $1 = (void *)malloc(arg4*sizeof(long));
            break;
            case FLOAT :
            $1 = (void *)malloc(arg4*sizeof(float));
            break;
            case DOUBLE :
            $1 = (void *)malloc(arg4*sizeof(double));
            break;
        }
}

%typemap(argout) void *out_descval {
	
	Tcl_Obj *obj;
	char *cp;
	double dval, *dp;
	int ival, *ip;
	float *fp;
	short *sp;

	switch(arg3) {

            case CHAR :
            cp = (char *)$1;
	    obj = Tcl_NewStringObj(cp,strlen(cp));
            break;

            case SHORT :
	    sp = (short *)$1;
            ival = *sp;
	    obj = Tcl_NewIntObj(ival);
            break;

            case INT :
            case LONG :
	    ip = (int *)$1;
	    obj = Tcl_NewIntObj(*ip);
            break;

            case FLOAT :
	    fp = (float *)$1;
	    dval = *fp;
	    obj = Tcl_NewDoubleObj(dval);
            break;

            case DOUBLE :
	    dp = (double *)$1;
	    obj = Tcl_NewDoubleObj(*dp);
            break;
        }
	Tcl_ObjSetVar2(interp,objv[5], NULL, obj, TCL_NAMESPACE_ONLY);
	free($1);
}

/* so that WR_tbl may accept direct values */

%typemap(in) void *in_tblval(short sval, int ip, float fval, double dp, char *cp) {

	int type;
	char format[20], unit[lg_unit+1];

	get_col_info(arg1,arg3, &type, format, unit);

        switch(type) {

            case CHAR :
            cp = Tcl_GetStringFromObj($input,0);
            $1 = (void *)cp;
            break;

            case SHORT :
            Tcl_GetIntFromObj(interp, $input, &ip);
            sval = (short)ip;
            $1 = (void *)&sval;
            break;

            case INT :
            case LONG :
            Tcl_GetIntFromObj(interp, $input, &ip);
            $1 = (void *)&ip;
            break;

            case FLOAT :
            Tcl_GetDoubleFromObj(interp, $input, &dp);
            fval = (float)dp;
            $1 = (void *)&fval;
            break;

            case DOUBLE :
            Tcl_GetDoubleFromObj(interp, $input, &dp);
            $1 = (void *)&dp;
            break;
        }
}

/* so that RD_tbl may accept tcl object to return a value */

%typemap(in) void *out_tblval(int type) {
	
	int len;
	char format[20], unit[lg_unit+1];

	get_col_info(arg1,arg3, &type, format, unit);

	switch(type) {

            case CHAR :
	    sscanf(format,"A%d",&len);
            $1 = (void *)malloc((len+1)*sizeof(char));
            break;
            case SHORT :
            $1 = (void *)malloc(1*sizeof(short));
            break;
            case INT :
            case LONG :
            $1 = (void *)malloc(1*sizeof(long));
            break;
            case FLOAT :
            $1 = (void *)malloc(1*sizeof(float));
            break;
            case DOUBLE :
            $1 = (void *)malloc(1*sizeof(double));
            break;
        }
}

%typemap(argout) void *out_tblval {
	
	Tcl_Obj *obj;
	char *cp;
	double dval, *dp;
	int ival, *ip;
	float *fp;
	short *sp;

	switch(type4) {

            case CHAR :
            cp = (char *)$1;
	    obj = Tcl_NewStringObj(cp,strlen(cp));
            break;

            case SHORT :
	    sp = (short *)$1;
            ival = *sp;
	    obj = Tcl_NewIntObj(ival);
            break;

            case INT :
            case LONG :
	    ip = (int *)$1;
	    obj = Tcl_NewIntObj(*ip);
            break;

            case FLOAT :
	    fp = (float *)$1;
	    dval = *fp;
	    obj = Tcl_NewDoubleObj(dval);
            break;

            case DOUBLE :
	    dp = (double *)$1;
	    obj = Tcl_NewDoubleObj(*dp);
            break;
        }
	Tcl_ObjSetVar2(interp,objv[4], NULL, obj, TCL_NAMESPACE_ONLY);
	free($1);
}
